<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 02/16/2005 *
 * ===================                          Last change: 01/21/2006 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : doubler_mails.php                                 *
 * -------------------------------------------------------------------- *
 * Short description : Send's out mails for doubled points              *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Sendet Mails bei vergueteter Verdoppelung aus    *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} elseif (!isExtensionActive('doubler')) {
	return;
}

// Do not execute when script is in CSS mode
if (getScriptOutputMode() != 0) return;

// Initialize variables
$jackpotPoints = '0'; $userPoints = '0';
if (isExtensionActive('jackpot')) $jackpotPoints = getJackpotPoints();

// Get total points of the doubler itself
$DOUBLER_POINTS = getDoublerTotalPointsLeft();
if ($DOUBLER_POINTS == '0') {
	// Exit here to prevent some SQL errors (SQL_QUERY_ESC doen't insert zeros! We need to fix this...)
	return;
} // END - if

// If not currently doubled set it to zero
unsetGetRequestParameter('DOUBLER_UID');
unsetPostRequestParameter('DOUBLER_UID');
setSession('DOUBLER_UID', '');
if (empty($GLOBALS['doubler_userid'])) $GLOBALS['doubler_userid'] = '0';

// Check for doubles which we can pay out
$result_total = SQL_QUERY_ESC("SELECT
	d.id, d.userid, d.points, d.remote_ip, d.timemark
FROM
	`{?_MYSQL_PREFIX?}_doubler` AS d
LEFT JOIN
	`{?_MYSQL_PREFIX?}_user_data` AS u
ON
	d.userid=u.userid
WHERE
	u.`status`='CONFIRMED' AND
	d.points <= %s AND
	d.points >= ({?doubler_min?} * 2) AND
	d.completed='N' AND
	d.is_ref='N'
ORDER BY
	d.timemark ASC",
	array(
		$DOUBLER_POINTS
	), __FILE__, __LINE__);

// Check for accounts with limitation
$result_main = SQL_QUERY_ESC("SELECT
	d.id, d.userid, d.points, d.remote_ip, d.timemark
FROM
	`{?_MYSQL_PREFIX?}_doubler` AS d
LEFT JOIN
	`{?_MYSQL_PREFIX?}_user_data` AS u
ON
	d.userid=u.userid
WHERE
	u.`status`='CONFIRMED' AND
	d.points <= %s AND
	d.points >= ({?doubler_min?} * 2) AND
	d.completed='N' AND
	d.is_ref='N'
ORDER BY
	d.timemark ASC
LIMIT {?doubler_max_sent?}",
	array(
		$DOUBLER_POINTS
	), __FILE__, __LINE__);

// Do we have entries found?
if (((SQL_NUMROWS($result_total) > 0) && (getConfig('doubler_sent_all') == 'Y')) || ((SQL_NUMROWS($result_main) == getConfig('doubler_group_sent')) && (getConfig('doubler_sent_all') != 'Y'))) {
	// Switch to matching SQL resource
	$result_load = $result_main;
	if ((SQL_NUMROWS($result_total) > 0) && (getConfig('doubler_sent_all') == 'Y')) $result_load = $result_total;

	// At least one account was found
	while ($content = SQL_FETCHARRAY($result_load)) {
		// Only double when points are enougth!
		if ($DOUBLER_POINTS >= $content['points']) {
			// Check for his ref points
			$ref = countSumTotalData($content['userid'], 'doubler', 'points', 'refid', false, " AND `completed`='N' AND `is_ref`='Y'");

			// Zero refid when empty (might be helpful!)
			if (empty($ref)) $ref = '0';

			if (($ref > 0) && ($GLOBALS['doubler_userid'] == $content['userid']) && (!empty($ref))) {
				// Referal points found so add them and set line(s) to completed='Y'
				$content['points'] += $ref;
				SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_doubler` SET `completed`='Y' WHERE `refid`=%s AND `completed`='N' AND `is_ref`='Y'",
					array(bigintval($content['userid'])), __FILE__, __LINE__);
			} else {
				// No referal points found
				$ref = '0';
			}

			// Exclude webmaster from doubling...
			if ($content['userid'] != getConfig('doubler_userid')) {
				// Add points
				addPointsDirectly(sprintf("doubler_%s", strtolower(getConfig('doubler_send_mode'))), $content['userid'], $content['points']);
			} // END - if

			// Set entry as "payed"
			SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_doubler` SET `completed`='Y' WHERE `id`=%s LIMIT 1",
				array(bigintval($content['id'])), __FILE__, __LINE__);

			$okay = false;

			// Check for jackpot inclusion in doubling process
			if (($jackpotPoints > 0) && ($jackpotPoints >= $content['points']) && (getConfig('doubler_jackpot') == 'Y')) {
				// Subtract points from jackpot
				subtractPointsFromJackpot($content['points']);
				$jackpotPoints -= $content['points'];

				// Okay, done!
				$okay = true;
			} // END - if

			// Exclude also webmaster's id in taking points from webmaster's account
			if (($userPoints > 0) && ($userPoints >= $content['points']) && ($okay === false) && (getConfig('doubler_userid') > 0) && ($content['userid'] != getConfig('doubler_userid'))) {
				// Add points to used points
				subtractPoints('doubler_payout', getConfig('doubler_userid'), $content['points']);

				// Okay, done!
				$okay = true;
			} // END - if

			// Update doubler's account only when others are not updated
			if ($okay === false) {
				// Add points to used doubler points
				updateConfiguration('doubler_used', $content['points'], '+');
			} // END - if

			// Update variables to prevent errors
			incrementConfigEntry('doubler_used', $content['points']);
			$DOUBLER_POINTS -= $content['points'];

			// Prepare array
			$content['timemark'] = generateDateTime($content['timemark'], 2);

			// Load mail template and send mail away...
			$message = loadEmailTemplate('member_doubler', $content, $content['userid']);
			sendEmail($content['userid'], '{--DOUBLER_MEMBER_SUBJECT--}', $message);
		} // END - if
	} // END - while
} // END - if

// Free memory
SQL_FREERESULT($result_total);
SQL_FREERESULT($result_main);

// [EOF]
?>
